require 'oop/tools'
require 'oop/basic_rules'

module OOP
  class Cell
    include Tools

    def _rules
      BasicRules.new
    end
  end
  def Cell(*rules_and_name_to_klass)
    rules, name_to_klass = if rules_and_name_to_klass.size > 1
                             rules_and_name_to_klass
                           else
                             [BasicRules, rules_and_name_to_klass.first]
                           end

    c = Class.new(Cell)
    c.class_exec do
      define_method(:_rules) { rules.new }
    end
    name_to_klass.each do |name, klass|
      c.class_exec do
        define_method(name) { klass }
      end
    end
    c
  end
  module_function :Cell
end
