module OOP
  module Tools
    module ClassMethods
      def message(meth, &block)
        define_method(meth) do |*args, &blk|
          args = args.map do |arg|
            _rules.cast_to_value(arg)
          end
          _rules.cast_to_value(self.instance_exec(*(args + [blk]), &block))
        end
      end
      def konstructor(*parts, &block)
        parts_hsh = if parts.last.is_a?(Hash)
          *parts, hsh = parts
          parts += hsh.keys
          parts.reduce({}){|m,e| m[e] = nil; m}.merge(hsh)
        else
          parts.reduce({}){|m,e| m[e] = nil; m}
        end
        define_method(:initialize) do |opts|
          if block
            opts = block.call(opts) || raise("#{self} invalid with #{opts}")
          end

          opts = opts.map{|k,v| [k.to_sym, v] }.to_h
          @opts = {}
          extra_args = (opts.keys - parts)
          missing_args = parts.select do |k|
            !opts.has_key?(k) && !parts_hsh.has_key?(k)
          end
          if extra_args.any?
            raise "extra args: #{extra_args}"
          elsif missing_args.any?
            raise "missing args: #{missing_args}"
          end

          opts.each do |k, v|
            k = k.to_sym
            if self.is_a? Value
              @opts[_rules.cast_to_value(k)] = _rules.cast_to_value(v)
            else
              @opts[k] = v
            end
          end
          @opts
        end
        parts_hsh.each do |part, defaultt|
          part = part.to_sym
          define_method(part) do
            @opts[part] ||= defaultt
          end
        end
      end
    end
    def self.included(klass)
      klass.extend(ClassMethods)
    end
  end
end
