require 'oop/tools'
require 'oop/basic_rules'

module OOP
  class Value
    include Tools

    def ==(other)
      @opts == other.instance_variable_get(:@opts)
    end

    private

    def _rules
      BasicRules.new
    end
  end

  def Value(*rules_and_name_to_klass)
    rules, name_to_klass = if rules_and_name_to_klass.size > 1
                             rules_and_name_to_klass
                           else
                             [BasicRules, rules_and_name_to_klass.first]
                           end
    c = Class.new(Value)
    c.class_exec do
      define_method(:_rules) { rules.new }
    end
    name_to_klass.each do |name, klass|
      if !(klass.is_a?(Value) || klass.ancestors.include?(Value) || rules.new.trusted_values.include?(klass))
        raise "imported non-value #{klass}"
      end
      c.class_exec do
        define_method(name) { klass }
      end
    end
    c
  end
  module_function :Value
end
